package CCSP.A2023.t1;
import java.util.*;

/**
 * @ProjectName: LeetCode
 * @FileName: Main
 * @Author: 杨逸
 * @Data:2024/10/11 9:17
 * @Description: TODO
 */
public class Main {
    public static final Scanner input = new Scanner(System.in);
    static int n,m,p,q,min = Integer.MAX_VALUE;
    static int[] target,giftCost;
    static List<Element> elements = new ArrayList<>();
    static Map<Integer,Integer> exchange = new HashMap<>();
    static Map<Integer,Boolean> exchangeFlag = new HashMap<>();
    static List<List<Integer>> gift = new ArrayList<>();
    static int cost = 0;
    static Set<Integer> currentSet = new HashSet<>();
    public static void main(String[] args) {
        n = input.nextInt();
        m = input.nextInt();
        p = input.nextInt();
        q = input.nextInt();
        target = new int[n];
        giftCost = new int[q];
        for (int i = 0; i < n; i++) {
            target[i] = input.nextInt();
        }
        for (int i = 0; i < m; i++) {
            int flag = input.nextInt();
            Element element = new Element(i + 1);
            if (0==flag){
                element.cost = input.nextInt();
            }else {
                element.flag = true;
                for (int j = 0; j < flag; j++) {
                    element.child.add(input.nextInt());
                }
            }
            elements.add(element);
        }
        for (int i = 0; i < p; i++) {
            int a = input.nextInt();
            int b = input.nextInt();
            //a换b
            exchange.put(b,a);
            exchangeFlag.put(b,false);
        }
        for (int i = 0; i < q; i++) {
            int n = input.nextInt();
            int cost = input.nextInt();
            ArrayList<Integer> list = new ArrayList<>();
            giftCost[i] = cost;
            for (int j = 0; j < n; j++) {
                list.add(input.nextInt());
            }
        }
    if (q==0){
        //没有礼盒的算法
        for (int v : target) {
            if (currentSet.contains(v))continue;
            dfs(v);
        }
        //valid();
        cost = min;
        System.out.println(cost);
    }else {

    }

    }

    private static void valid() {
        for (int v : target) {
            if (!currentSet.contains(v)) {
                System.out.println("不合法");
                dfs(v);
                valid();
                //return;
            }
        }
    }

    private static void dfs(int v) {
        Element element = elements.get(v - 1);
        boolean flag = false;
        //交换
        Integer value = exchange.get(element.id);
        if (exchange.containsKey(element.id)&&currentSet.contains(value)&&(!exchangeFlag.get(element.id))){
                currentSet.remove(value);
                currentSet.add(element.id);
                exchangeFlag.put(element.id,true);
                flag = false;
            for (int val : target) {
                if (currentSet.contains(val))continue;
                dfs(val);
                flag = true;
            }
            exchangeFlag.put(element.id,false);
            if (!flag&&min>cost){
                //如果目标集都包含，则更新最小值
                min = cost;
            }
            //恢复
            currentSet.remove(element.id);
            currentSet.add(value);
        }
        //买礼盒
        if (element.flag){
            //合成
            List<Integer> list = element.child;
            for (int child : list) {
                if (currentSet.contains(child))continue;
                dfs(child);
            }
            for (Integer integer : list) {
                currentSet.remove(integer);
            }
        }else {
            //直接兑换
            cost+=element.cost;
        }
            currentSet.add(element.id);

        flag = false;
        for (int val : target) {
            if (currentSet.contains(val))continue;
            //dfs(val);
            flag = true;
        }
        if (!flag&&min>cost){
            //如果目标集都包含，则更新最小值
            min = cost;
        }
    }
}

class Element{
    public Element(int id) {
        this.id = id;
    }

    int id;//编号
    int cost;//成本
    boolean flag = false;//是否需要合成
    List<Integer> child = new ArrayList<>();//合成成本
}
