package CSP.A202203.A1;

import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;
/**
 * @Projectname: LeetCode
 * @Filename: CSP.A202203.A1.CSP.A201312.A1.CSP.A202305.A2.CSP.A202303.A2.CSP.A201612.A2.CSP.A202212.A2.CSP.A202209.A2.CSP.A202206.A2.CSP.A202203.A2.CSP.A202305.A3.CSP.A202303.A3.CSP.A202212.A3.CSP.temp.A1.CSP.temp.A2.CSP.temp.A3.CSP.temp.A4.CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/8/16 11:27
 * @Description: 未初始化警告-第一题
 */
public class Main {
    private static int n;
    private static int k;
    private static Map<Integer,Integer> leftKey;
    private static int[] rightKey;

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        n = scanner.nextInt();
        k = scanner.nextInt();

        leftKey = new HashMap<Integer,Integer>();
        rightKey = new int[k];
        //左值和右值分别保存
        //左值保存到哈希表中,记录下出现在第几行
        //右值保存到数组中
        for (int i = 0; i < k; i++) {
            int l = scanner.nextInt();
            int r = scanner.nextInt();
            if (!leftKey.containsKey(l)){
                //记录变量第一次出现的时候
                leftKey.put(l,i);
            }
            rightKey[i] = r;
        }

        //统计右未初始化的赋值语句条数
        int count = 0;
        for (int i = 0; i < rightKey.length; i++) {
            if (rightKey[i] != 0){
                //0一般认为是常量
                Integer integer = leftKey.get(rightKey[i]);
                if (integer == null || integer>= i){
                    //没有该变量或者变量出现的行数在当前行的后面
                    count++;
                }
            }
        }

        //输出结果

        System.out.println(count);
    }
}
