package CSP.A202203.A2;

import java.util.*;

/**
 * @Projectname: LeetCode
 * @Filename: CSP.A202203.A2.CSP.A202305.A3.CSP.A202303.A3.CSP.A202212.A3.CSP.temp.A1.CSP.temp.A2.CSP.temp.A3.CSP.temp.A4.CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/8/30 15:43
 * @Description: 出行计划-第二题
 */
public class Main {
    private final static Scanner input = new Scanner(System.in);
    private static Map<Integer,List<Integer>> map = new HashMap<>();
    private static int[] result;
    private static int[][] date;
    private static int n;
    private static int m;
    private static int k;
    public static void main(String[] args) {
        n = input.nextInt();
        m = input.nextInt();
        k = input.nextInt();
        //按出行时间取哈希,保存不同出现时间的核酸要求
        result  = new int[m];
        if (n <= 1000) {
            date = new int[n][2];
            //保存出现时间
            for (int i = 0; i < n; i++) {
                date[i] = new int[]{input.nextInt(),input.nextInt()};
            }
            for (int i = 0; i < m; i++) {
                int count = 0;
                int start = input.nextInt()+k;
                for (int j = 0; j < n; j++) {
                    if (date[j][0] >= start && start+date[j][1] > date[j][0])count++;
                }
                result[i] = count;
            }

        }else {
            int max  =0;
            for (int i = 0; i < n; i++) {
                int key = input.nextInt();
                List<Integer> temp = map.getOrDefault(key, new ArrayList<Integer>());
                int val = input.nextInt();
                if (val > max)max = val;
                temp.add(val);
                map.put(key, temp);
            }
            for (int i = 0; i < m; i++) {
                int count = 0;
                int start = input.nextInt() + k;
                for (int j = start; j <=max; j++) {
                    List<Integer> list = map.getOrDefault(j, new ArrayList<>());
                    for (Integer integer : list) {
                        if (j < start + integer) count++;
                    }
                }
                result[i] = count;
            }
        }
        for (int i : result) {
            System.out.println(i);
        }
    }
}
