package CSP.A202206.A2;

import java.util.*;

/**
 * @Projectname: LeetCode
 * @Filename: CSP.A202206.A2.CSP.A202203.A2.CSP.A202305.A3.CSP.A202303.A3.CSP.A202212.A3.CSP.temp.A1.CSP.temp.A2.CSP.temp.A3.CSP.temp.A4.CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/8/30 14:07
 * @Description: 寻宝！大冒险！-第二题
 */
public class Main {
    private final static Scanner input = new Scanner(System.in);
    private static List<List<Integer>> data = new ArrayList<>();
    //保存树的坐标
    private static Map<T,T> map = new HashMap<>();
    private static int[][] Sgrid;
    private static int[][] Lgrid;
    private static int n;
    private static int L;
    private static int S;
    public static void main(String[] args) {
        n = input.nextInt();
        L = input.nextInt();
        S = input.nextInt();
        Sgrid = new int[S+1][S+1];

        int count = 0;
        if (L <= 2000){
            Lgrid = new int[L+1][L+1];
            //还原绿化图
            for (int i = 0; i < n; i++) {
                int x = input.nextInt(),y = input.nextInt();
                ArrayList<Integer> temp = new ArrayList<>();
                temp.add(x);
                temp.add(y);
                data.add(temp);
                Lgrid[x][y] = 1;
            }
            //将宝藏图反转输入
            for (int i = 0; i <= S; i++) {
                for (int j = 0; j <= S; j++) {
                    Sgrid[S-i][j] = input.nextInt();
                }
            }

            //对比坐标
            for (int i = 0; i < n; i++) {
                List<Integer> list = data.get(i);
                int x0 = list.get(0),y0 = list.get(1);
                boolean flag = true;
                //越界则跳过
                if (x0+S > L || y0 + S > L)continue;
                for (int k = 0; k <= S; k++) {
                    for (int j = 0; j <= S; j++) {
                        if (Sgrid[k][j] != Lgrid[k+x0][j+y0]){
                            flag = false;
                            break;
                        }
                    }
                        if (!flag)break;
                }
                if (flag)count++;
            }
            System.out.println(count);
        }else {
            //读取坐标
            for (int i = 0; i < n; i++) {
                T t = new T(input.nextInt(),input.nextInt());
                map.put(t,t);
            }

            //将宝藏图反转输入
            for (int i = 0; i <= S; i++) {
                for (int j = 0; j <= S; j++) {
                    Sgrid[S-i][j] = input.nextInt();
                }
            }

            //对比坐标
            for (T t : map.keySet()) {
                int x0 = t.x,y0 = t.y;
                boolean flag = true;
                //越界则跳过
                if (x0+S > L || y0 + S > L)continue;
                for (int k = 0; k <= S; k++) {
                    for (int j = 0; j <= S; j++) {
                        if ((Sgrid[k][j]==1 && !map.containsKey(new T(k+x0,j+y0)))|| ((Sgrid[k][j]==0 && map.containsKey(new T(k+x0,j+y0))))){
                            flag = false;
                            break;
                        }
                    }
                    if (!flag)break;
                }
                if (flag)count++;
            }
            System.out.println(count);
        }




    }
}
class T{
    int x;
    int y;

    public T(int x, int y) {
        this.x = x;
        this.y = y;
    }

    @Override
    public int hashCode() {
        return 1;
    }

    @Override
    public boolean equals(Object obj) {
        T o = (T)obj;
        return this.x == o.x && this.y == o.y;
    }
}