package CSP.A202209.A1;

import java.util.Scanner;
/**
 * @Projectname: LeetCode
 * @Filename: CSP.A202209.A1.CSP.A202203.A1.CSP.A201312.A1.CSP.A202305.A2.CSP.A202303.A2.CSP.A201612.A2.CSP.A202212.A2.CSP.A202209.A2.CSP.A202206.A2.CSP.A202203.A2.CSP.A202305.A3.CSP.A202303.A3.CSP.A202212.A3.CSP.temp.A1.CSP.temp.A2.CSP.temp.A3.CSP.temp.A4.CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/8/16 10:37
 * @Description: 如此编码-第一题
 */
public class Main {
    private static int n;
    private static int code;
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        n = scanner.nextInt();
        code = scanner.nextInt();
        int[] data = new int[n];
        int[] c = new int[n+1];
        int[] b = new int[n];
        //输入题目的选项数量
        for (int i = 0; i < data.length; i++) {
            data[i] = scanner.nextInt();
        }

        //计算c
        c[0] = 1;
        for (int i = 0; i < data.length; i++) {
            int temp = data[i];
            c[i+1] = temp*c[i];
        }

        //计算b
        //使用动态规划计算,pd保存多项式的前 (n-1) 项的和
        int[] pd = new int[n];
        b[0] = (code % c[1])/c[0];
        pd[0] = b[0]*c[0];
        for (int i = 1; i < b.length; i++) {
            b[i] = ((code % c[i+1]) - pd[i-1])/c[i];
            pd[i] = pd[i-1] + b[i]*c[i];
        }

        //输出结果,调整格式
        System.out.print(b[0]);
        for (int i = 1; i < b.length; i++) {
            System.out.print(" " + b[i]);
        }
    }
}
