package CSP.A202212.A2;

import java.util.*;

/**
 * @Projectname: LeetCode
 * @Filename: CSP.A202212.A2.CSP.A202209.A2.CSP.A202206.A2.CSP.A202203.A2.CSP.A202305.A3.CSP.A202303.A3.CSP.A202212.A3.CSP.temp.A1.CSP.temp.A2.CSP.temp.A3.CSP.temp.A4.CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/8/23 14:46
 * @Description: 训练计划-第二题
 */
public class Main {
    private final static Scanner input = new Scanner(System.in);
    public static void main(String[] args) {
        int n = input.nextInt();
        int m = input.nextInt();
        //记录最长的训练天数
        int max = 0;
        int[] start1 = new int[m];
        int[] start2 = new int[m];
        for (int i = 0; i < start2.length; i++) {
            start2[i] = Integer.MAX_VALUE;
        }
        Map<Integer,P> map = new HashMap<>();
        for (int i = 0; i < m; i++) {
            //创建训练项目
            P p1 = new P(i+1);
            int pre = input.nextInt();
            if (pre!=0){
                //设置前置训练项目
                P p2 = map.get(pre);
                p1.pre = p2;
                p2.next = p1;
            }
            map.put(i+1,p1);
        }
        for (int i = 0; i < m; i++) {
            //设置训练时间
           map.get(i+1).time = input.nextInt();
        }
        //链表
        for (int i = 0; i < m; i++) {
            P p = map.get(i+1);
            int temp = p.time;
            //最早开始时间
            int t = 1;
            while(p.pre != null){
                p = p.pre;
                t += p.time;
            }
            start1[i] = t;
            if (temp+t>max)max = temp+t;
            //start2[i]  = n - (temp+t)+2;
        }

        for (int i : start1) {
            System.out.print(i + " ");
        }
        if (max-1 > n)return;

        //for (int i = 0; i < m; i++) {
        //    CSP.A202212.A2.P p = map.get(i+1);
        //    int t = p.time;
        //    while(p.next!=null){
        //        p = p.next;
        //        t += p.time;
        //    }
        //    start2[i] = n-t+1;
        //}
        for (int i = 0; i < m; i++) {
            P p = map.get(i + 1);
            P temp = p;
            int sum = temp.time;
            if (temp.next == null && temp.pre != null){
                while(temp.pre != null){
                    temp = temp.pre;
                    sum += temp.time;
                }
                temp = p;
                int total = n+(n-sum);
                while(temp != null){
                    if (start2[temp.code-1] > total - temp.time + 1)start2[temp.code-1]  = total - temp.time + 1;
                    sum -= temp.time;
                    total -=temp.time;
                    temp = temp.pre;
                }
            }else if (temp.next == null && temp.pre == null){
            //没有前置训练项目,也不是其他训练项目的前置
                start2[i] = n - sum+1;
            }
        }
        //打印最晚开始时间
        System.out.println();
        for (int i : start2) {
            System.out.print(i + " ");
        }
    }
}
class P{
    int code;
    int time;
    P next = null;
    P pre = null;

    public P(int code) {
        this.code = code;
    }
}
