package CSP.A202303.A1; /**
 * @Projectname: LeetCode
 * @Filename: CSP.A202303.A1.CSP.A202212.A1.CSP.A202209.A1.CSP.A202203.A1.CSP.A201312.A1.CSP.A202305.A2.CSP.A202303.A2.CSP.A201612.A2.CSP.A202212.A2.CSP.A202209.A2.CSP.A202206.A2.CSP.A202203.A2.CSP.A202305.A3.CSP.A202303.A3.CSP.A202212.A3.CSP.temp.A1.CSP.temp.A2.CSP.temp.A3.CSP.temp.A4.CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/8/16 9:49
 * @Description: 丈量土地-第一题
 */
import java.util.Scanner;
public class Main {
    private static int a;
    private static int b;
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        a = scanner.nextInt();
        b = scanner.nextInt();

        int sum = 0;
        //使用二维数组保存土地的坐标
        int[][] data = new int[n][4];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 4; j++) {
                data[i][j] = scanner.nextInt();
            }
        }

        //遍历计算,面积
        for (int i = 0; i < n; i++) {
            int x1 = data[i][0];
            int y1 = data[i][1];
            int x2 = data[i][2];
            int y2 = data[i][3];
            //先排除超出范围的情况
            if ((x1 < 0 && x2 < 0) || (x1 >a && x2 > a) || (y1 < 0 && y2 < 0) || (y1 > b && y2 > b)){
                continue;
            }
            //计算在范围内的宽width
            int width = 0;
            if ((x1 < 0 && (x2 >= 0 && x2 <= a)) || (x2 < 0 && (x1 >= 0 && x1 <= a))){
                //一个越高左边界一个在范围内
                if (x1 < 0){
                    width = x2;
                }else{
                    width = x1;
                }
            }else if ((x1 > a && (x2 >= 0 && x2 <= a)) || (x2 > a && (x1 >= 0 && x1 <= a))){
                //一个越高右边界,一个在范围内
                if (x1 > a){
                    width = a - x2;
                }else{
                    width = a - x1;
                }
            }else{
                //两个都在范围内
                width = Math.abs(x1-x2);
            }
            //计算在范围内的高high
            int high = 0;
            if ((y1 < 0 && (y2 >= 0 && y2 <= b)) || (y2 < 0 && (y1 >= 0 && y1 <= b))){
                //一个越高下边界,一个在范围内
                if (y1 < 0){
                    high = y2;
                }else{
                    high = y1;
                }
            }else if ((y1 > b && (y2 >= 0 && y2 <= b)) || (y2 > b && (y1 >= 0 && y1 <= b))){
                //一个越高上边界,一个在范围内
                if (y1 > b){
                    high = b - y2;
                }else{
                    high = b - y1;
                }
            }else {
                //两个都在范围内
                high = Math.abs(y1-y2);
            }
            //计算在范围内的面积
            sum += width*high;
        }

        System.out.println(sum);
    }
}
