package CSP.A202305.A2;

import java.util.Scanner;
/**
 * @Projectname: LeetCode
 * @Filename: CSP.A202305.A2.CSP.A202303.A2.CSP.A201612.A2.CSP.A202212.A2.CSP.A202209.A2.CSP.A202206.A2.CSP.A202203.A2.CSP.A202305.A3.CSP.A202303.A3.CSP.A202212.A3.CSP.temp.A1.CSP.temp.A2.CSP.temp.A3.CSP.temp.A4.CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/8/16 14:47
 * @Description: 矩阵运算-第二题
 */
public class Main {
    private static int n;
    private static int d;
    private static long[][] Q;
    private static long[][] K;
    private static long[][] V;
    private static long[] W;

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        //输入矩阵的规模
        n = scanner.nextInt();
        d = scanner.nextInt();
        //初始化矩阵
        Q = new long[n][d];
        K = new long[n][d];
        V = new long[n][d];
        //初始化向量
        W = new long[n];

        //输入数据
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < d; j++) {
                Q[i][j] = scanner.nextInt();
            }
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < d; j++) {
                K[i][j] = scanner.nextInt();
            }
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < d; j++) {
                V[i][j] = scanner.nextInt();
            }
        }
        for (int i = 0; i < n; i++) {
            W[i] = scanner.nextInt();
        }
        //将K转置
        long[][] Kt = new long[d][n];
        for (int i = 0; i < K.length; i++) {
            for (int j = 0; j < K[0].length; j++) {
                Kt[j][i] = K[i][j];
            }
        }

        //计算矩阵Kt与矩阵V,先计算后面主要是为了降维
        long[][] temp1 = new long[d][d];
        for (int i = 0; i < d; i++) {
            for (int j = 0; j < d; j++) {
                long t = 0;
                for (int k = 0; k < n; k++) {
                    t += Kt[i][k]*V[k][j];
                }
                temp1[i][j] = t;
            }
        }

        //计算矩阵Q与矩阵temp1
        long[][] temp2 = new long[n][d];
        for (int i = 0; i < n; i++) {
            //行
            for (int j = 0; j < d; j++) {
                //列
                long t = 0;
                for (int k = 0; k < d; k++) {
                    //列的每一个元素
                    t += Q[i][k] * temp1[k][j];
                }
                temp2[i][j] = t;
            }
        }

        //计算向量W与矩阵temp2的点乘
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < d; j++) {
                temp2[i][j] = W[i] * temp2[i][j];
            }
        }

        //输出结果
        for (int i = 0; i < temp2.length; i++) {
            for (int j = 0; j < temp2[0].length; j++) {
                System.out.print(temp2[i][j]);
                if (j == temp2[0].length-1){
                    //最后一个元素打印换行
                    System.out.println("");
                }else{
                    //否则打印空格
                    System.out.print(" ");
                }
            }
        }
    }
}
