package CSP.A202305.A3;

import java.util.Scanner;
/**
 * @Projectname: LeetCode
 * @Filename: CSP.A202305.A3.CSP.A202303.A3.CSP.A202212.A3.CSP.temp.A1.CSP.temp.A2.CSP.temp.A3.CSP.temp.A4.CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/8/30 17:25
 * @Description: 解压缩-第三题
 */
public class Main {
    private static final Scanner input = new Scanner(System.in);
    private static int s;
    private static StringBuilder data = new StringBuilder();
    private static StringBuilder result = new StringBuilder();
    public static void main(String[] args) {
        s = input.nextInt();
        int row;
        if (s%8==0){
            row = s/8;
        }else{
            row = s/8+1;
        }
        //数据输入
        for (int i = 0; i < row; i++) {
            data.append(input.next());
        }
        //读取引导域
        int left = 0,index = 0;
        //保存引导区的数据
        int[] bytes = new int[4];
        while(index < 4){
            String str = data.substring(left, left + 2);
            left +=2;

            int val = Integer.parseInt(str,16);
            bytes[index++] = val&127;
            if ((val &128)==0){
                break;
            }
        }
        //通过引导区,计算原数据的长度
        //开始恢复数据
        int length = 0;
        for (int i = 0; i < bytes.length; i++) {
            length += bytes[i]*Math.pow(128,i);
        }

        while(length > 0 && left+2 < data.length()){
            //判断是字面量还是回溯应用
            String str = data.substring(left, left + 2);
            left +=2;
            int val = Integer.parseInt(str, 16);
            if ((val&3)==0){
                //字面量
                for (int i = 0; i < bytes.length; i++) {
                    bytes[i] = 0;
                }

                //恢复字面量的长度
                if ((val>>2) < 60){
                    //小于60的情况
                    result.append(data.substring(left,left+((val>>2)+1)*2));
                    left += ((val>>2)+1)*2;
                    length -= ((val>>2)+1);
                }else if ((val>>2)==60){
                    //长度为后一个字节
                    for (int i = 0; i < 1; i++) {
                        str = data.substring(left,left+2);
                        left +=2;
                        val = Integer.parseInt(str,16);
                        bytes[i] = val;
                    }
                    int len = 1;
                    for (int i = 0; i < 1; i++) {
                        len += bytes[i]*Math.pow(128,i);
                    }
                    result.append(data.substring(left,left+len*2));
                    left +=len*2;
                    length -= len;
                }else if ((val>>2)==61){
                    //长度为后两个字节
                    for (int i = 0; i < 2; i++) {
                        str = data.substring(left,left+2);
                        left +=2;
                        val = Integer.parseInt(str,16);
                        bytes[i] = val;
                    }
                    int len = 1;
                    for (int i = 0; i < 2; i++) {
                        len += bytes[i]*Math.pow(128,i);
                    }
                    result.append(data.substring(left,left+len*2));
                    left +=len*2;
                    length -= len;
                }else if ((val>>2)==62){
                    //后三个字节
                    for (int i = 0; i < 3; i++) {
                        str = data.substring(left,left+2);
                        left +=2;
                        val = Integer.parseInt(str,16);
                        bytes[i] = val;
                    }
                    int len = 1;
                    for (int i = 0; i < 3; i++) {
                        len += bytes[i]*Math.pow(128,i);
                    }
                    result.append(data.substring(left,left+len*2));
                    left +=len*2;
                    length -= len;
                }else{
                    //后四个字节
                    for (int i = 0; i < 4; i++) {
                        str = data.substring(left,left+2);
                        left +=2;
                        val = Integer.parseInt(str,16);
                        bytes[i] = val;
                    }
                    int len = 1;
                    for (int i = 0; i < 4; i++) {
                        len += bytes[i]*Math.pow(128,i);
                    }
                    result.append(data.substring(left,left+len*2));
                    left +=len*2;
                    length -= len;
                }
            }else{
                //回溯引用
                int len = 0;
                int order = 0;
                if ((val&3)==1){
                    //01回溯引用
                    //计算l
                    len = ((val&28) >> 2)+4;

                    //计算o
                    order = Integer.parseInt(((val&224) >> 5)+data.substring(left,left+2),16);
                    left += 2;
                }else {
                    //10回溯引用
                    //计算l
                    len = (val>>2)+1;
                    //计算o
                    order = Integer.parseInt(data.substring(left+2,left+4)+data.substring(left,left+2),16);
                    left += 4;
                }

                //还原回溯引用的数据
                if (len > order){
                    int tLen = len;
                    //反复拼接已解压的后order个字符
                    while (tLen > order){
                        result.append(result.substring(result.length()-order*2,result.length()));
                        tLen -= order;
                    }
                    //不足order个字符,但还需要拼接
                    if (tLen > 0){
                        result.append(result.substring(result.length()-order*2,result.length()-order*2+tLen*2));
                    }
                }else{
                    result.append(result.substring(result.length() -  2*(order),result.length() - 2*(order)+len*2));
                }
                length -= len;

            }

        }

        //输出
        left = 0;
        while(left+16 <= result.length()){
            System.out.println(result.substring(left,left+16));
            left +=16;
        }
        if (left<result.length()){
            System.out.println(result.substring(left,result.length()));
        }
    }
}

//测试用例,字面量为60
//75
//4824010203040506
//0708090af03c0001
//0203040506070809
//0a0b0c0d0e0f0102
//030405060708090a
//0b0c0d0e0f010203
//0405060708090a0b
//0c0d0e0f01020304
//05060708090a0b0c
//0d0e0f