package CSP.temp.A4;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * @Projectname: LeetCode
 * @Filename: CSP.temp.A4.CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/9/2 15:36
 * @Description: U144818 求和方法
 */
public class Main {
    private final static Scanner input = new Scanner(System.in);
    private static int N;
    private static int M;
    private static int answer = 0;
    private static List<Integer> A = new ArrayList<>();
    private static List<Integer> B = new ArrayList<>();
    private static List<List<Integer>> data = new ArrayList<>();
    private static List<Integer> temp = new ArrayList<>();

    //枚举选哪一个
    public static void main(String[] args) {

        N = input.nextInt();
        M = input.nextInt();
        //数据输入
        for (int i = 0; i < N; i++) {
            A.add(input.nextInt());
        }
        for (int i = 0; i < N; i++) {
            B.add(input.nextInt());
        }

        for (int i = 0; i < N; i++) {
            ArrayList<Integer> list = new ArrayList<>();
            Integer a = A.get(i);
            Integer b = B.get(i);
            if (a >= b){
                for (int j = b; j <= a; j++) {
                    list.add(j);
                }
            }else{
                for (int j = a; j <= b; j++) {
                    list.add(j);
                }
            }
            data.add(list);
        }
        dfs2(0,0);
        System.out.println(answer);
    }

    //n:A序列第n个选不选,m:B序列第m个选不选
    private static void dfs(int n,int m){
        //求和,判断
       if (temp.size()>1){
           int sum =0;
           for (Integer integer : temp) {
               sum += integer;
           }
           if (sum == M)answer++;

       }

       if (n < N){
           //选A序列第n个
           temp.add(A.get(n));
           dfs(n+1,m);
           //还原现场
           temp.remove(Integer.valueOf(A.get(n)));

           //不选A序列第n个
           dfs(n+1,m);
       }


       if (m < N){
           //选B序列第m个
           temp.add(B.get(m));
           dfs(n,m+1);
           //还原现场
           temp.remove(Integer.valueOf(B.get(m)));

           //不选B序列第m个
           dfs(n,m+1);
       }
    }

    //枚举选哪一个
    private static void dfs2(int n,int sum){
        if (n >= N){
            if (sum == M)answer++;
            return;
        }
        List<Integer> list = data.get(n);
        for (int i = 0; i < list.size(); i++) {
            //选这个
            dfs2(n+1,sum+list.get(i));

            //选下一个
        }
    }
}
