package weekContest.A361.A1;

import java.util.HashSet;

class Solution {
    public int countSymmetricIntegers(int low, int high) {
        //数据范围内的所有对称整数加入哈希表
        HashSet<Integer> set = new HashSet<>();
        int count = 0;
        //10-99
        for (int i = 10; i < 100; i++) {
            if (isOK(i))set.add(i);
        }
        //1000-9999
        for (int i = 1000; i < 10000; i++) {
            if (isOK(i))set.add(i);
        }

        for (int i = low; i <= high ; i++) {
            if (set.contains(i))count++;
        }
        return count;
    }

    boolean isOK(int val){
        String str = String.valueOf(val);
        int n = str.length()/2;
        int sum1 = 0,sum2 = 0;
        for (int i = 0; i < n; i++) {
            sum1 += str.charAt(i);
            sum2 += str.charAt(2*n-1-i);
        }
        return sum1==sum2;
    }
}