package CCSP.A2023.t2;

import java.util.*;

/**
 * @ProjectName: LeetCode
 * @FileName: Main
 * @Author: 杨逸
 * @Data:2024/10/12 14:47
 * @Description: TODO
 */
public class Main {
    public static final Scanner input = new Scanner(System.in);
    static int n,m,a,b,k,s;
    static List<Ball> balls = new ArrayList<>();
    static long count = 0;
    static Set<Ball> currentBalls1 = new HashSet<>();
    static Set<Integer> currentBallIds1 = new HashSet<>();
    static Set<Integer> currentBallColors1 = new HashSet<>();
    static List<Set<Ball>> setList = new ArrayList<>();
    public static void main(String[] args) {
            n = input.nextInt();
            m = input.nextInt();
            a = input.nextInt();
            b = input.nextInt();
            k = input.nextInt();
            s = input.nextInt();

        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= a; j++) {
                balls.add(new Ball(j,i));
            }
        }
        for (int i = n+1; i <= m+n; i++) {
            for (int j = 1; j <= b; j++) {
                balls.add(new Ball(j,i));
            }
        }
            if (s==1){
                //for (int i = 0; i < balls.size(); i++) {
                //    dfs1(i);
                //    dfs1(i+1);
                //}
                count = dfs1(0);
                //count = colorDFS(0)*idDFS(0);
                System.out.println(count%998_244_353);
            }else {

            }
    }

    /**
     * 编号的排列组合
     * @return int
     * @description:
     * @author: 杨逸
     * @data:2024/10/12 15:47:08
     * @since 1.0.0
     */
    private static int idDFS(int index) {
        int result = 0;
        int len = a>b?a:b;
        if (len >= currentBallIds1.size()){
            return 1;
        }
        if (index>=len)return result;
        for (int i = 0; i < len; i++) {
            if (currentBallIds1.contains(i))continue;
            currentBallIds1.add(i);
            result+=idDFS(index+1);
            //选
            currentBallIds1.remove(i);
            result+=idDFS(index+1);
            //不选
        }
        return result;
    }

    /**
     * 颜色的排列组合
     * @return int
     * @description:
     * @author: 杨逸
     * @data:2024/10/12 15:46:51
     * @since 1.0.0
     */
    private static int colorDFS(int index) {
        if (k==currentBallColors1.size()){
            return 1;
        }
        int result = 0;
        if (index>=n+m)return result;
        for (int i = index; i < n + m; i++) {
            if (currentBallColors1.contains(i))continue;
            currentBallColors1.add(i);
        //选这个颜色
             result += colorDFS(index+1);
             currentBallColors1.remove(i);
        //不选这个颜色
            result+=colorDFS(index+1);
        }
        return result;
    }

    private static long dfs1(int index) {
        long result = 0L;
        if (k == currentBalls1.size()){
            //count++;
            return valid();
            //for (Ball ball : currentBalls1) {
            //    System.out.println(ball);
            //}
            //System.out.println("=====");
            //return 1;
        }
        if (index>= balls.size())return result;
        Ball ball = balls.get(index);
        if (currentBallIds1.contains(ball.id)||currentBallColors1.contains(ball.color)){
            //不选
            result+=dfs1(index+1);
        }else {
            //选
            currentBalls1.add(ball);
            currentBallIds1.add(ball.id);
            currentBallColors1.add(ball.color);
            result+=dfs1(index+1);
            currentBallColors1.remove(ball.color);
            currentBallIds1.remove(ball.id);
            currentBalls1.remove(ball);
            //不选
            result+=dfs1(index+1);
        }


        //for (Ball ball : balls) {
        //    if (currentBalls1.contains(ball)||currentBallIds1.contains(ball.id)||currentBallColors1.contains(ball.color))continue;
        //    //选
        //    currentBalls1.add(ball);
        //    currentBallIds1.add(ball.id);
        //    currentBallColors1.add(ball.color);
        //    dfs1();
        //    currentBallColors1.add(ball.color);
        //    currentBallIds1.remove(ball.id);
        //    currentBalls1.remove(ball);
        //    //不选
        //    dfs1();
        //}
        return result;
    }

    private static int valid() {
        if (setList.size()!=0){
            for (Set<Ball> ballSet : setList) {
                if (currentBalls1.contains(ballSet)) {
                    return 0;
                }
                boolean flag = true;
                for (Ball ball : currentBalls1) {
                    //有一个不存在即可
                    flag = flag && ballSet.contains(ball);
                    if (flag==false){
                        break;
                    }
                }
                if (flag){
                    return 0;
                }
            }
        }
        HashSet<Ball> balls = new HashSet<>();
        for (Ball ball : currentBalls1) {
            balls.add(ball);
        }
        setList.add(balls);
        return 1;
    }
}

class Ball{
    public Ball(int id, int color) {
        this.id = id;
        this.color = color;
    }

    @Override
    public String toString() {
        return "Ball{" +
                "id=" + id +
                ", color=" + color +
                '}';
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Ball ball = (Ball) o;
        return id == ball.id && color == ball.color;
    }

    @Override
    public int hashCode() {
        return Objects.hash(color);
    }

    int id;//编号
    int color;//颜色
}
