package CSP.A201312.A1;

import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;
/**
 * @Projectname: LeetCode
 * @Filename: CSP.A201312.A1.CSP.A202305.A2.CSP.A202303.A2.CSP.A201612.A2.CSP.A202212.A2.CSP.A202209.A2.CSP.A202206.A2.CSP.A202203.A2.CSP.A202305.A3.CSP.A202303.A3.CSP.A202212.A3.CSP.temp.A1.CSP.temp.A2.CSP.temp.A3.CSP.temp.A4.CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/8/16 14:30
 * @Description: 出现次数最多的数-第一题
 */
public class Main {
    private static int n;
    private static Map<Integer,Integer> numCount;
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        n = scanner.nextInt();
        numCount = new HashMap<Integer,Integer>();
        //数据输入
        for (int i = 0; i < n; i++) {
            int value = scanner.nextInt();
            if (numCount.containsKey(value)){
                numCount.put(value,numCount.get(value)+1);
            }else{
                numCount.put(value,1);
            }
        }
        //统计出现最多的次数
        int max = 0;
        for (Integer value : numCount.values()) {
            if (value > max) max = value;
        }

        //获得出现次数最多的数,且是次数最多数值最小的数
        int min = Integer.MAX_VALUE;
        for (Integer integer : numCount.keySet()) {
            int temp = numCount.get(integer);
            if (temp == max && integer < min){
                min = integer;
            }
        }
        System.out.println(min);
    }
}
