package CSP.A202206.A1; /**
 * @Projectname: LeetCode
 * @Filename: CSP.A202303.A1.CSP.A202212.A1.CSP.A202209.A1.CSP.A202203.A1.CSP.A201312.A1.CSP.A202305.A2.CSP.A202303.A2.CSP.A201612.A2.CSP.A202212.A2.CSP.A202209.A2.CSP.A202206.A2.CSP.A202203.A2.CSP.A202305.A3.CSP.A202303.A3.CSP.A202212.A3.CSP.temp.A1.CSP.temp.A2.CSP.temp.A3.CSP.temp.A4.CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/8/15 10:27
 * @Description: 归一化处理-第一题
 */
import java.util.Arrays;
import java.util.Scanner;

public class Main {
    //平均值
    public static double avg;
    //方差
    public static double variance;
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        //输入n个数据
        int n = scanner.nextInt();

        //保存输出的结果
        double[] input = new double[n];
        //保存输出结果
        double[] result = new double[n];

        //输入数据
        for (int i = 0; i < n; i++) {
            input[i] = scanner.nextInt();
        }

        //计算平均值
        avg = Arrays.stream(input).sum()/n;
        //计算方差
        variance = Arrays.stream(input).map(operand -> (operand - avg)*(operand - avg)).sum()/n;
        //计算结果
        for (int i = 0; i < input.length; i++) {
            result[i] = (input[i] - avg)/Math.sqrt(variance);
        }
        //输出
        for (double v : result) {
            System.out.println(v);
        }
    }
}
