package CSP.A202303.A2;

import java.util.*;

/**
 * @Projectname: LeetCode
 * @Filename: CSP.A202303.A2.CSP.A201612.A2.CSP.A202212.A2.CSP.A202209.A2.CSP.A202206.A2.CSP.A202203.A2.CSP.A202305.A3.CSP.A202303.A3.CSP.A202212.A3.CSP.temp.A1.CSP.temp.A2.CSP.temp.A3.CSP.temp.A4.CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/8/16 18:58
 * @Description: 开垦田地-第二题
 */

public class Main {



    private static int n;
    private static int m;
    private static int k;
   //保存每一块田地的优先队列
    public static Queue<Main>  queue = new PriorityQueue<>((o1, o2) -> o2.T - o1.T);

    //将封装田地的属性
    public int T;
    public int C;

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        n = scanner.nextInt();
        m = scanner.nextInt();
        k = scanner.nextInt();
        //数据输入
        for (int i = 0; i < n; i++) {
            queue.add(new Main(scanner.nextInt(),scanner.nextInt()));
        }

        while(true){
            //取出队列头的值,并修改
            Main node = queue.poll();
            if (node.T > k && m > node.C){
                //满足条件,修改天数
                if (node.T > 3000*k && m > node.C*3000){
                    node.T -= 3000;
                    m -= node.C*3000;
                }else{
                node.T -=1;
                m -= node.C;
                }
            queue.add(node);
            }else{
                //没有满足条件的田地,退出循环
            queue.add(node);
                break;
            }
        }

        //输出最大天数
        System.out.println(queue.poll().T);
    }

    public Main(int t, int c) {
        T = t;
        C = c;
    }
}
