package CSP.temp.A2;

import java.util.Deque;
import java.util.LinkedList;
import java.util.Scanner;

/**
 * @Projectname: LeetCode
 * @Filename: CSP.temp.A2.CSP.temp.A3.CSP.temp.A4.CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/9/2 13:39
 * @Description: U188794 连续数列
 */
public class Main {
    private final static Scanner input = new Scanner(System.in);
    private static int n;
    private static int[] data;
    private static Deque<Integer> stack = new LinkedList<>();

    public static void main(String[] args) {
        n = input.nextInt();
        //n <=10e6
        int max = 0;
        data = new int[n];
        for (int i = 0; i < n; i++) {
            data[i] = input.nextInt();
        }
        //单调栈,求下一个更大值

        for (int i = 0; i < n; i++) {
            if (max > (n-i))break;
            //清空栈
            stack.clear();
            for (int j = i; j < n; j++) {
                int val = data[j];
                if (stack.isEmpty()){
                    stack.push(val);
                }else if (stack.peek()+1 == val){
                    stack.push(val);
                }
            }
            //保存最大值
            if (stack.size()>max)max = stack.size();
        }

        System.out.println(max);
    }
}
