package CSP.temp.A5;

import java.util.*;

/**
 * @Projectname: LeetCode
 * @Filename: CSP.temp.A5.Main
 * @Author: 杨逸
 * @Data:2023/9/2 16:09
 * @Description: U143195 物资运输
 */
public class Main {
    private final static Scanner input = new Scanner(System.in);
    private static int n;
    private static int k;
    private static List<G> data = new ArrayList<>();
    private static int answer = 0;

    public static void main(String[] args) {
        n = input.nextInt();
        k = input.nextInt();
        //输入货物的信息
        for (int i = 0; i < n; i++) {
            G g = new G(input.nextInt(), input.nextInt());
            data.add(g);
        }
        //排序,按平均价值
        //data.sort(new Comparator<CSP.temp.A5.G>() {
        //    @Override
        //    public int compare(CSP.temp.A5.G o1, CSP.temp.A5.G o2) {
        //        int flag  =0;
        //        if (o2.avg - o1.avg >= 0){
        //            flag = 1;
        //        }else {
        //            flag = -1;
        //        }
        //        return flag;
        //    }
        //});

        //按价值排序
        data.sort((g1,g2)->g2.v-g1.v);
        for (int i = 0; i < k; i++) {
            int c = input.nextInt();

            if (data.size() > 0 && c >= data.get(data.size()-1).w){
                for (int j = 0; j < data.size(); j++) {
                    if (data.get(j).w <= c){
                        answer += data.get(j).v;
                        data.remove(j);
                        break;
                    }
                }
            }
        }

        System.out.println(answer);
    }
}

class G{
    int w;
    int v;
    double avg;

    public G(int w, int v) {
        this.w = w;
        this.v = v;
        avg = Double.valueOf(v)/w;
    }
}