package luogu.t5;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

/**
 * @Projectname: LeetCode
 * @Filename: Main
 * @Author: 杨逸
 * @Data:2023/11/26 15:45
 * @Description:
 */
public class Main {
        static int result = 0;
        static int temp = 0;
        static Set<Integer> path = new HashSet<>();
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        int[][]  graph = new int[n][n];
        for (int i = 0; i < n-1; i++) {
            int x = scanner.nextInt()-1;
            int y = scanner.nextInt()-1;
            int v = scanner.nextInt();
            graph[x][y] = v;
            graph[y][x] = v;
        }
        for (int i = 0; i < n; i++) {
            dfs(graph,i);
        }
        System.out.println(result);

    }

    private static void dfs(int[][] graph, int number) {
        path.add(number);
        for (int i = 0; i < graph[0].length; i++) {
            if (graph[number][i]>0 && path.contains(i)==false){
                temp += graph[number][i];
                if (temp>result)result = temp;
                dfs(graph,i);
                temp -= graph[number][i];
            }
        }
        path.remove(number);
    }


}
