package weekContest.A361.A3;

import java.util.HashMap;
import java.util.List;

class Solution {
    //前缀和+同余定理+哈希表辅助统计+两数之和思想
    public long countInterestingSubarrays(List<Integer> nums, int modulo, int k) {
        long count = 0,pre = 0;
        for (int i = 0; i < nums.size(); i++) {
            if (nums.get(i)%modulo==k){
                nums.set(i,1);
            }else{
                nums.set(i,0);
            }
        }
        HashMap<Long, Integer> map = new HashMap<>();
        map.put(Long.valueOf(0),1);

        for (Integer num : nums) {
            pre += num;
            //累加出现相同余数的次数
            count += map.getOrDefault((pre%modulo-k+modulo)%modulo,0);
            //将当前出现的余数+1保存
            map.put(pre%modulo,map.getOrDefault(pre%modulo,0)+1);
        }

        return count;
    }
}