package weekContest.A400.A3;

import java.util.PriorityQueue;

/**
 * @ProjectName: LeetCode
 * @FileName: Solution
 * @Author: 杨逸
 * @Data:2024/6/2 10:18
 * @Description:
 */
public class Solution {
    public String clearStars(String s) {
        int[] flag = new int[s.length()];
        PriorityQueue<Node> priorityQueue = new PriorityQueue<>((a,b)->a.v-b.v);
        for (int i = 0; i < s.length(); i++) {
            char c = s.charAt(i);
            if (c=='*'){
                flag[i]=1;
                Node node = priorityQueue.poll();
                flag[node.index]=1;
            }else {
                Node node = new Node(c, i);
                priorityQueue.add(node);
            }
        }

        StringBuilder ans = new StringBuilder();
        for (int i = 0; i < flag.length; i++) {
            if (flag[i]==0)ans.append(s.charAt(i));
        }
        return ans.toString();
    }

    private String t(String s){
        int[] flag = new int[s.length()];
        for (int i = s.length()-1; i >= 0; i--) {
            if (s.charAt(i)=='*') {
                flag[i] = 1;
                int min = 'z'+1;
                int index = i-1;
                for (int j = i-1;j>= 0;j--){
                    char c = s.charAt(j);
                    if (c=='*' || flag[j]==1)continue;
                    if (c<min){
                        index = j;
                        min = c;
                    }
                    if (c=='a')break;
                }
                flag[index]=1;
            }
        }

        StringBuilder ans = new StringBuilder();
        for (int i = 0; i < flag.length; i++) {
            if (flag[i]==0)ans.append(s.charAt(i));
        }
        return ans.toString();
    }
    class Node implements Comparable{
        int v;
        int index;

        public Node(int v, int index) {
            this.v = v;
            this.index = index;
        }

        @Override
        public int compareTo(Object o) {
            return this.v - ((Node) o).v;
        }
    }
}
